"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../../src/index");

var _chai = require("chai");

var _enzyme = require("enzyme");

var _enzymeAdapterReact = _interopRequireDefault(require("enzyme-adapter-react-16"));

(0, _enzyme.configure)({
  adapter: new _enzymeAdapterReact["default"]()
});

var _ref =
/*#__PURE__*/
_react["default"].createElement("div", null);

describe('Test Section', function () {
  var TestEl =
  /*#__PURE__*/
  function (_PureComponent) {
    (0, _inherits2["default"])(TestEl, _PureComponent);

    function TestEl() {
      (0, _classCallCheck2["default"])(this, TestEl);
      return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(TestEl).apply(this, arguments));
    }

    (0, _createClass2["default"])(TestEl, [{
      key: "render",
      value: function render() {
        return _ref;
      }
    }]);
    return TestEl;
  }(_react.PureComponent);

  var FakeComponent =
  /*#__PURE__*/
  function (_PureComponent2) {
    (0, _inherits2["default"])(FakeComponent, _PureComponent2);

    function FakeComponent() {
      (0, _classCallCheck2["default"])(this, FakeComponent);
      return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(FakeComponent).apply(this, arguments));
    }

    (0, _createClass2["default"])(FakeComponent, [{
      key: "render",
      value: function render() {
        var _this = this;

        var _this$props = this.props,
            immutable = _this$props.immutable,
            name = _this$props.name;
        return _react["default"].createElement(_index.Section, {
          name: name,
          immutable: immutable
        }, _react["default"].createElement(TestEl, {
          ref: function ref(el) {
            return _this.el = el;
          }
        }));
      }
    }]);
    return FakeComponent;
  }(_react.PureComponent);

  (0, _defineProperty2["default"])(FakeComponent, "defaultProps", {
    name: 'test'
  });
  beforeEach(function () {
    return (0, _index.dispatch)('config/reset');
  });

  var _ref2 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, null);

  it('Section is existed', function () {
    var vDom = _ref2;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    (0, _chai.expect)(uFake.el.props.aaa).to.deep.equal({
      bbb: 'ccc'
    });
    (0, _chai.expect)(uFake.el.props.I18N).to.deep.equal({
      ddd: 'fff'
    });
  });

  var _ref3 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, {
    name: "xxx"
  });

  it('Section is not existed', function () {
    var vDom = _ref3;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: null
    });
    (0, _chai.expect)('undefined' === typeof uFake.el).to.be["true"];
  });

  var _ref4 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, {
    immutable: true
  });

  it('Section is existed with immutable', function () {
    var vDom = _ref4;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      },
      I18N: {
        ddd: 'fff'
      }
    });
    (0, _chai.expect)(uFake.el.props.aaa.toJS()).to.deep.equal({
      bbb: 'ccc'
    });
    (0, _chai.expect)(uFake.el.props.I18N.toJS()).to.deep.equal({
      ddd: 'fff'
    });
  });

  var _ref5 =
  /*#__PURE__*/
  _react["default"].createElement(FakeComponent, {
    name: "xxx",
    immutable: true
  });

  it('Section is not existed with immutable', function () {
    var vDom = _ref5;
    var uFake = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: null
    });
    (0, _chai.expect)('undefined' === typeof uFake.el).to.be["true"];
  });
  it('pass name to child', function () {
    var PassName =
    /*#__PURE__*/
    function (_PureComponent3) {
      (0, _inherits2["default"])(PassName, _PureComponent3);

      function PassName() {
        (0, _classCallCheck2["default"])(this, PassName);
        return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(PassName).apply(this, arguments));
      }

      (0, _createClass2["default"])(PassName, [{
        key: "render",
        value: function render() {
          var _this2 = this;

          var _this$props2 = this.props,
              immutable = _this$props2.immutable,
              name = _this$props2.name;
          return _react["default"].createElement(_index.Section, {
            name: "test"
          }, _react["default"].createElement("div", {
            ref: function ref(el) {
              return _this2.el = el;
            }
          }));
        }
      }]);
      return PassName;
    }(_react.PureComponent);

    var vDom = _react["default"].createElement(PassName, null);

    var wrap = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    (0, _chai.expect)(wrap.el.getAttribute('name')).to.equal('test');
  });
  it('not pass name if child already have name', function () {
    var NotPassName =
    /*#__PURE__*/
    function (_PureComponent4) {
      (0, _inherits2["default"])(NotPassName, _PureComponent4);

      function NotPassName() {
        (0, _classCallCheck2["default"])(this, NotPassName);
        return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(NotPassName).apply(this, arguments));
      }

      (0, _createClass2["default"])(NotPassName, [{
        key: "render",
        value: function render() {
          var _this3 = this;

          var _this$props3 = this.props,
              immutable = _this$props3.immutable,
              name = _this$props3.name;
          return _react["default"].createElement(_index.Section, {
            name: "test"
          }, _react["default"].createElement("div", {
            name: "test2",
            ref: function ref(el) {
              return _this3.el = el;
            }
          }));
        }
      }]);
      return NotPassName;
    }(_react.PureComponent);

    var vDom = _react["default"].createElement(NotPassName, null);

    var wrap = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    (0, _chai.expect)(wrap.el.getAttribute('name')).to.equal('test2');
  });
  it('not pass name if one of child already have name', function () {
    var NotPassNameMultiChild =
    /*#__PURE__*/
    function (_PureComponent5) {
      (0, _inherits2["default"])(NotPassNameMultiChild, _PureComponent5);

      function NotPassNameMultiChild() {
        (0, _classCallCheck2["default"])(this, NotPassNameMultiChild);
        return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(NotPassNameMultiChild).apply(this, arguments));
      }

      (0, _createClass2["default"])(NotPassNameMultiChild, [{
        key: "render",
        value: function render() {
          var _this4 = this;

          var _this$props4 = this.props,
              immutable = _this$props4.immutable,
              name = _this$props4.name;
          return _react["default"].createElement(_index.Section, {
            name: "test"
          }, _react["default"].createElement("div", {
            ref: function ref(el) {
              return _this4.el1 = el;
            }
          }), _react["default"].createElement("div", {
            name: "test2",
            ref: function ref(el) {
              return _this4.el2 = el;
            }
          }));
        }
      }]);
      return NotPassNameMultiChild;
    }(_react.PureComponent);

    var vDom = _react["default"].createElement(NotPassNameMultiChild, null);

    var wrap = (0, _enzyme.mount)(vDom).instance();
    (0, _index.dispatch)({
      section: {
        test: {
          shouldRender: true,
          aaa: {
            bbb: 'ccc'
          }
        }
      }
    });
    (0, _chai.expect)(wrap.el1.getAttribute('name')).to.be["null"];
    (0, _chai.expect)(wrap.el2.getAttribute('name')).to.equal('test2');
  });
});